<?php
require("/www/cgi-bin/inc/head.inc");
require("/www/cgi-bin/inc/menu.inc");
include_once("/www/cgi-bin/inc/function.inc");
include_once("/www/cgi-bin/inc/wrcfg.inc");

//AQL
require_once("/www/cgi-bin/inc/aql.php");
?>


<?php
function show_sip_adv()
{
	$aql = new aql();
	$setok = $aql->set('basedir','/www/config');
	if (!$setok) {
		exit(255);
	}
	
	$hlock=lock_file("/www/config/sip_general.conf");
	$res = $aql->query("select * from sip_general.conf where section='sipgeneral'");
	$sipgeneral='sipgeneral';
	unlock_file($hlock);

	if(isset($res[$sipgeneral]['localip'])) {
		$localip = trim($res[$sipgeneral]['localip']);
	}else{
		$localip ='';
	}
	if(isset($res[$sipgeneral]['port'])) {
		$port = trim($res[$sipgeneral]['port']);
	}else{
		$port ='';
	}
	if(isset($res[$sipgeneral]['DtmfLength'])) {
		$DtmfLength = trim($res[$sipgeneral]['DtmfLength']);
	}else{
		$DtmfLength ='';
	}
	if(isset($res[$sipgeneral]['RegSipInterval'])) {
		$RegSipInterval = trim($res[$sipgeneral]['RegSipInterval']);
	}else{
		$RegSipInterval ='';
	}	
	$codec['alaw'] = '';
	$codec['mulaw'] = '';
	$codec['G729'] = '';
	if(isset($res[$sipgeneral]['codec'])) {
		$val = trim($res[$sipgeneral]['codec']);
		if(strcasecmp($val,'alaw') == 0) {
			$codec['alaw'] =  'selected';
		} else if(strcasecmp($val,'mulaw') == 0) {
			$codec['mulaw'] =  'selected';
		}else if(strcasecmp($val,'G729') == 0) {
			$codec['G729'] =  'selected';
		}
		 else {
			$codec['alaw'] = 'selected';
		}
	}
	if(isset($res[$sipgeneral]['language'])) {
		$language = trim($res[$sipgeneral]['language']);
	} else {
		$language = '';
	}

$setok = $aql->set('basedir','/www/config');
if (!$setok) {
	echo __LINE__.' '.$aql->get_error();
	exit;
}
	$hlock=lock_file("/www/config/gw.conf");
	$res = $aql->query("select * from gw.conf");
	$gw='gw';
	unlock_file($hlock);

	if(isset($res[$gw]['language'])) {
		$weblanguage = trim($res[$gw]['language']);
	}else{
		$weblanguage ='';
	}	
?>
<script type="text/javascript" src="/js/functions.js">
</script>
<script type="text/javascript" src="/js/check.js">
</script>
<script type="text/javascript">
function check()
{
	var lport = document.getElementById('localport').value;
	document.getElementById('cport').innerHTML = '';
	var RegSipInterval = document.getElementById('RegSipInterval').value;
	document.getElementById('cRegSipInterval').innerHTML = '';	
  var rstr;
	if(rstr=check_num(lport)) 
	{
		document.getElementById('cport').innerHTML = con_str(rstr);
		return false;
	}
	if(rstr=check_num(RegSipInterval)) {
		document.getElementById("cRegSipInterval").innerHTML = con_str(rstr);
		return false;
	}	
	return true;
}
</script>
	<form id="manform" name="manform" enctype="multipart/form-data" action="<?php echo $_SERVER['PHP_SELF'] ?>" method="post">
	<input type="hidden" id="rebootpromt" name="rebootpromt" value="" />
	<input type="hidden" id="LANGCHANGE" name="LANGCHANGE" value="" />
	<div id="tab">
		<li class="tb1">&nbsp;</li>
		<?php
  		if($weblanguage=='chinese'){
  			echo "<li class=\"tbg\">SIP ߼</li>";
  		}else{
		?>
			<li class="tbg">SIP Advance Setting</li>
	<?php
			}
		?>			
		<li class="tb2">&nbsp;</li>
	</div>
	<table width="100%" class="tshow">
			<tr>
				<th>
				<?php
		  		if($weblanguage=='chinese'){
		  			echo "<div class=\"helptooltips\">";
		  			echo "SkypeIPַ";
		  			echo "<span class=\"showhelp\">";
		  			echo "SkypeڻIP.";
		  			echo "</span>";
		  			echo "</div>";
		  		}else{
				?>
					<div class="helptooltips">
						Skype Gateway IP Address:
						<span class="showhelp">
						IP of PC Sky2Sip installed. <br/>
						</span>
					</div>
			<?php
					}
				?>					
				</th>
				<td >
					<select size=1 name="localip" id="localip" >
					<?php 
					if(!empty($_SERVER["SERVER_NAME"])){
					  $cip = $_SERVER["SERVER_NAME"];
					  if(is_array($cip)){
					  	$selip='';
					  	foreach($cip as $lip){
					  		if($selip==''){
					  			$selip=	$lip;
					  		}
								if($lip == $localip) {
									$selip=$localip;
									$select = 'selected';
								} else {
									$select = '';
								}
								echo "<option value=\"$lip\" $select>";
								echo "$lip";
								echo '</option>';
					  	}
					  }else if($cip){
					  	$selip=	$cip;
								echo "<option value=\"$cip\" >";
								echo "$cip";
								echo '</option>';
					  }
					}
					else{
					  $cip = "޷ȡ";
					  if($localip){
								echo "<option value=\"$localip\" >";
								echo "$localip";
								echo '</option>';
					  }else {
								echo "<option value=\"1\" >";
								echo "޷ȡ";
								echo '</option>';
					  }
					}
					?>
					</select>
				</td>
			</tr>	
			<tr>
				<th>
				<?php
		  		if($weblanguage=='chinese'){
		  			echo "<div class=\"helptooltips\">";
		  			echo "SkypeSIP˿ںţ";
		  			echo "<span class=\"showhelp\">";
		  			echo "SkypeغSIPͨѶ˿ڣSkypeغSIPͬһ̨<br>˶˿ڲΪ5060.";
		  			echo "</span>";
		  			echo "</div>";
		  		}else{
				?>
					<div class="helptooltips">
						Skype Gateway SIP Port:
						<span class="showhelp">
						The communication port that the Skype gateway connects with the SIP server through.<br> 
						If the Skype gateway and SIP server are in the same machine, the port can not be 5060.
						</span>
					</div>
			<?php
					}
				?>
				</th>
				<td >
					<input  type="text" name="localport" id="localport" value="<?php echo $port?>" /><span id="cport"></span>
				</td>
			</tr>
			<tr>
				<th>
				<?php
		  		if($weblanguage=='chinese'){
		  			echo "<div class=\"helptooltips\">";
		  			echo "˫Ƶ: ";
		  			echo "<span class=\"showhelp\">";
		  			echo "40ms~120ms裬SIP绰аͽԴõĳȷͳȥ.";
		  			echo "</span>";
		  			echo "</div>";
		  		}else{
				?>
					<div class="helptooltips">
						DTMF Generate:
						<span class="showhelp">
						40ms to 120ms are available. <br>
						</span>
					</div>
			<?php
					}
				?>					
				</th>
				<td >
					<select size=1 name="DtmfLength" id="DtmfLength" >
					<?php 
				  	for($i=0;$i<4;$i++){
				  		$val=40+20*$i;
							if($val == $DtmfLength) {
								$select = 'selected';
							} else {
								$select = '';
							}
							echo "<option value=\"$val\" $select>";
							echo "$val"." ms";
							echo '</option>';
				  	}
					?>
					</select>
				</td>
			</tr>	
			<tr>
				<th>
				<?php
		  		if($weblanguage=='chinese'){
		  			echo "<div class=\"helptooltips\">";
		  			echo "ע()";
		  			echo "<span class=\"showhelp\">";
		  			echo "עSIP˺עᵽSIPʱʱ.";
		  			echo "</span>";
		  			echo "</div>";
		  		}else{
				?>
					<div class="helptooltips">
						Registered Interval(s):
						<span class="showhelp">
						Also known as heartbeat time, which is the interval time SIP account registers to SIP server.<br/>
						</span>
					</div>
			<?php
					}
				?>					
				</th>
				<td >
					<input type="text" id="RegSipInterval" name="RegSipInterval" value="<?php echo $RegSipInterval?>" /><span id="cRegSipInterval"></span>
				</td>
			</tr>	
			<tr>
				<th>
				<?php
		  		if($weblanguage=='chinese'){
		  			echo "<div class=\"helptooltips\">";
		  			echo "ʾ: ";
		  			echo "<span class=\"showhelp\">";
		  			echo "ѡʾӢʾ.";
		  			echo "</span>";
		  			echo "</div>";
		  		}else{
				?>
					<div class="helptooltips">
						Prompt Tone Language:
						<span class="showhelp">
						Chinese and English are available. <br>
						</span>
					</div>
			<?php
					}
				?>						
				</th>
				<td >
					<select size=1 name="language" id="language" >
					<?php 
						if($language) {
							if($language=='English') {
								echo "<option value=\"English\" selected>"."English";
								echo "<option value=\"Chinese\" >"."Chinese";
							} else {
								echo "<option value=\"English\" >"."English";
								echo "<option value=\"Chinese\" selected>"."Chinese";
							}
						}else{
								echo "<option value=\"English\" selected>"."English";
								echo "<option value=\"Chinese\" >"."Chinese";
						}
						echo '</option>';
					?>
					</select>
				</td>
			</tr>		
			<tr>
				<th>
				<?php
		  		if($weblanguage=='chinese'){
		  			echo "<div class=\"helptooltips\">";
		  			echo "ʽ";
		  			echo "<span class=\"showhelp\">";
		  			echo "Skype֧UlawAlaw֣<br>ΪSkypeغSIP绰ͨõƵʽ.";
		  			echo "</span>";
		  			echo "</div>";
		  		}else{
				?>
					<div class="helptooltips">
						Audio Codec:
						<span class="showhelp">
						The setting is for the selection of audio code communicating <br/>
						between the Skype gateway and SIP server.
						</span>
					</div>
			<?php
					}
				?>					
				</th>
				<td >
					<select size=1 name="codec" id="codec" onchange="registration_change()">
						<option value="alaw"    <?php echo $codec['alaw']?>> alaw </option>
						<option value= "mulaw" <?php echo $codec['mulaw']?>> ulaw </option>
						<option value= "G729" <?php echo $codec['G729']?>> G729 </option>
				</select>
				</td>
			</tr>
	</table>
	<div id="newline"></div>
				<?php
		  		if($weblanguage=='chinese'){
		  			echo "<input type=\"submit\" name=\"send\" value=\"\"  onclick=\"return check();\"/>";
		  		}else{
				?>
				<input type="submit" name="send" value="Save"  onclick="return check();"/>
			<?php
					}
				?>	
	</form>
<?php
	//Save to gw_endpoints.conf
	///////////////////////////////////////////////////
			$aqlsr = new aql();
			$setok = $aqlsr->set('basedir','/www/config');
			if (!$setok) {
				exit(255);
			}
			
			$conf_path = "/www/config/sip_general.conf";
			$hlock = lock_file($conf_path);
			if(!file_exists($conf_path)) {
				fclose(fopen($conf_path,"w"));
			}
		
			if(!$aqlsr->open_config_file($conf_path)){
				echo $aqlsr->get_error();
				unlock_file($hlock);
				return false;
			}			
			$aqlsr->assign_editkey('sipgeneral','localip',$selip);
			if (!$aqlsr->save_config_file('sip_general.conf')) {
				echo $aqlsr->get_error();
				unlock_file($hlock);
				return false;
			}
			unlock_file($hlock);	
	//Save to gw_endpoints.conf
}
?>
<?php
function save_sip_adv()
{
	if(isset($_POST['localip'])) {
		$localip = $_POST['localip'];
	} else {
		$localip ='';
		echo "Please select gateway ip";
		exit(255);
	}
	if(isset($_POST['localport']) && $_POST['localport'] != '') {
		$port = $_POST['localport'];
	} else {
		echo "Please set port number";
		exit(255);
	}
	if(isset($_POST['RegSipInterval']) && $_POST['RegSipInterval'] != '') {
		$RegSipInterval = $_POST['RegSipInterval'];
	} else {
		echo "Please set Registered Interval";
		exit(255);
	}
	//Save to gw_endpoints.conf
	///////////////////////////////////////////////////
	$datachunk = '';
	$section='sipgeneral';
	if(isset($_POST['localip'])) {
		$localip = $_POST['localip'];
		$datachunk .= 'localip='.$localip."\n";
	} else {
		$datachunk .= 'localip='."\n";
		$localip ='';
	}
	if(isset($_POST['localport']) && $_POST['localport'] != '') {
		$port = $_POST['localport'];
		$datachunk .= 'port='.$port."\n";
	} else {
		$datachunk .= 'port='."\n";
	}
	if(isset($_POST['DtmfLength'])) {
		$DtmfLength = $_POST['DtmfLength'];
			$datachunk .= 'DtmfLength='.$DtmfLength."\n";
	} else {
		$datachunk .= 'DtmfLength='."\n";
	}
	if(isset($_POST['RegSipInterval']) && $_POST['RegSipInterval'] != '') {
		$RegSipInterval = $_POST['RegSipInterval'];
			$datachunk .= 'RegSipInterval='.$RegSipInterval."\n";
	} else {
		$datachunk .= 'RegSipInterval='."\n";
	}
	if(isset($_POST['language'])) {
		$language = $_POST['language'];
		$datachunk .= 'language='.$language."\n";
	} else {
		$datachunk .= 'language='."\n";
		$language = '';
	}
	if(isset($_POST['codec']) && $_POST['codec'] != '') {
		$_codec = $_POST['codec'];
		$datachunk .= 'codec='.$_codec."\n";
	} else {
		$datachunk .= 'codec='."\n";
		$_codec = '';
	}
	//Save to gw_endpoints.conf
	///////////////////////////////////////////////////
	$conf_path = '/www/config/sip_general.conf';
	$hlock = lock_file($conf_path);
	if (!file_exists($conf_path)) fclose(fopen($conf_path,"w"));
	$aql = new aql();
	$aql->set('basedir','/www/config');
	if(!$aql->open_config_file($conf_path)){
		echo $aql->get_error();
		unlock_file($hlock);
		return;
	}
	$aql->assign_delsection($section);
	$aql->save_config_file('sip_general.conf');
	$aql->assign_addsection($section,$datachunk);
	$aql->save_config_file('sip_general.conf');
	unlock_file($hlock);
	///////////////////////////////////////////////////
}
function save_rebootpromt()
{
$aql = new aql();

$setok = $aql->set('basedir','/www/config');
if (!$setok) {
	echo __LINE__.' '.$aql->get_error();
	exit;
}
	$hlock=lock_file("/www/config/gw.conf");
	$res = $aql->query("select * from gw.conf");
	$gw='gw';
	unlock_file($hlock);

	if(isset($res[$gw]['Gwstate'])) {
		$Gwstate = trim($res[$gw]['Gwstate']);
	}else{
		$Gwstate ='';
	}
	if(isset($res[$gw]['language'])) {
		$language = trim($res[$gw]['language']);
	}else{
		$language ='';
	}		
	$section='gw';
	$datachunk='';
	$datachunk.="Gwstate=".$Gwstate."\n";
	$datachunk.="Rebootpromt=1"."\n";
	$datachunk.="language=".$language."\n";
	//Save to gw_endpoints.conf
	///////////////////////////////////////////////////
	$conf_path = '/www/config/gw.conf';
	$hlock = lock_file($conf_path);
	if (!file_exists($conf_path)) fclose(fopen($conf_path,"w"));
	$aql = new aql();
	$aql->set('basedir','/www/config');
	if(!$aql->open_config_file($conf_path)){
		echo $aql->get_error();
		unlock_file($hlock);
		 return(false);
	}
	$aql->assign_delsection($section);
	$aql->save_config_file('gw.conf');
	$aql->assign_addsection($section,$datachunk);
	$aql->save_config_file('gw.conf');
	unlock_file($hlock);
	 return(true);
	///////////////////////////////////////////////////
}
?>
<?php
	if($_POST) {
		$aqlgw = new aql();
		$setok = $aqlgw->set('basedir','/www/config');
		$hlock=lock_file("/www/config/gw.conf");
		$res = $aqlgw->query("select * from gw.conf");
		$gw='gw';
		unlock_file($hlock);
		if(isset($res[$gw]['Gwstate'])) {
			$Gwstate = trim($res[$gw]['Gwstate']);
		}else{
			$Gwstate ='';
		}
		if(isset($res[$gw]['Rebootpromt'])) {
			$Rebootpromt = trim($res[$gw]['Rebootpromt']);
		}else{
			$Rebootpromt ='';
		}
		if(isset($res[$gw]['language'])) {
			$language = trim($res[$gw]['language']);
		}else{
			$language ='';
		}			
		if ((isset($_POST['send']) && $_POST['send'] == 'Save')||
		(isset($_POST['send']) && $_POST['send'] == '')) {
			if(save_rebootpromt()){
				save_sip_adv();
			}
			?>
				<script type="text/javascript">
					window.location.href='sip-adv-settings.php';
				</script>
				<?php
		} elseif (isset($_POST['LANGCHANGE'])&&$_POST['LANGCHANGE']==1) {
			$aqlgw = new aql();	
			$setok = $aqlgw->set('basedir','/www/config');
			if (!$setok) {
				echo __LINE__.' '.$aqlgw->get_error();
				exit;
			}
				$hlock=lock_file("/www/config/gw.conf");
				$res = $aqlgw->query("select * from gw.conf");
				$gw='gw';
				unlock_file($hlock);
			
				if(isset($res[$gw]['Gwstate'])) {
					$Gwstate = trim($res[$gw]['Gwstate']);
				}else{
					$Gwstate ='';
				}
				if(isset($res[$gw]['Rebootpromt'])) {
					$Rebootpromt = trim($res[$gw]['Rebootpromt']);
				}else{
					$Rebootpromt ='';
				}
				if(isset($res[$gw]['language'])) {
					$language = trim($res[$gw]['language']);
				}else{
					$language ='';
				}	
			if($language=='chinese'){
					$language='english';
			}else{
					$language='chinese';
			}			
			$section='gw';
			$datachunk='';
			$datachunk.="Gwstate=".$Gwstate."\n";
			$datachunk.="Rebootpromt=".$Rebootpromt."\n";
			$datachunk.="language=".$language."\n";
			//Save to gw_endpoints.conf
			///////////////////////////////////////////////////
			$conf_path = '/www/config/gw.conf';
			$hlock = lock_file($conf_path);
			if (!file_exists($conf_path)) fclose(fopen($conf_path,"w"));
			$aql = new aql();
			$aql->set('basedir','/www/config');
			if(!$aql->open_config_file($conf_path)){
				echo $aql->get_error();
				unlock_file($hlock);
				 return(false);
			}
			$aql->assign_delsection($section);
			$aql->save_config_file('gw.conf');
			$aql->assign_addsection($section,$datachunk);
			$aql->save_config_file('gw.conf');
			unlock_file($hlock);
			?>
				<script type="text/javascript">
					window.location.href='sip-adv-settings.php';
				</script>
				<?php
		} else{			
			if(isset($_POST['rebootpromt'])&&$_POST['rebootpromt']==1){
			$aqlsr = new aql();
			$setok = $aqlsr->set('basedir','/www/config');
			if (!$setok) {
				exit(255);
			}
			
			$conf_path = "/www/config/gw.conf";
			$hlock = lock_file($conf_path);
			if(!file_exists($conf_path)) {
				fclose(fopen($conf_path,"w"));
			}
		
			if(!$aqlsr->open_config_file($conf_path)){
				echo $aqlsr->get_error();
				unlock_file($hlock);
				return false;
			}			
			$aqlsr->assign_editkey('gw','Gwstate','reboot');
			$aqlsr->assign_editkey('gw','Rebootpromt','0');
			if (!$aqlsr->save_config_file('gw.conf')) {
				echo $aqlsr->get_error();
				unlock_file($hlock);
				return false;
			}
			unlock_file($hlock);
			?>
				<script type="text/javascript">
					window.location.href='sip-adv-settings.php';
				</script>
				<?php
				$delay=100000000;
				while($delay){
					$delay--;
				}
			}else{
				show_sip_adv();
			}
		}
	} else {
		show_sip_adv();
	}
?>

<?php require("/www/cgi-bin/inc/boot.inc");?>

